
; 2011-11-05
; - modified Line to Rect
; - localized variables
; - changed indentation (for IDEal)

;****************************************************************************************************
;**
;** Gradient
;**
;****************************************************************************************************

;Const Gradient_Up = 1
;Const Gradient_Down = 2
;Const Gradient_Left = 3
;Const Gradient_Right = 4

Type Gradient
    Field OffsetX
    Field OffsetY
    Field SizeX
    Field SizeY
    ;Field Direction
    Field Count
End Type

Function Gradient_Create.Gradient ()
    Gradient_Destroy
    Local Gradient.Gradient = New Gradient
    Gradient\OffsetX = 0
    Gradient\OffsetY = 0
    Gradient\SizeX = 0
    Gradient\SizeY = 0
    ;Gradient\Direction = Gradient_Down
    Gradient\Count = 0
    Return Gradient
End Function

Function Gradient_Destroy ()
    Delete Each Gradient
    Delete Each Gradient_Color
End Function

Function Gradient_Set ( PosX , PosY , SizeX , SizeY ) ;, Direction = Gradient_Down )
    Local Gradient.Gradient = First Gradient
    Gradient\OffsetX = PosX
    Gradient\OffsetY = PosY
    Gradient\SizeX = SizeX
    Gradient\SizeY = SizeY
    ;Gradient\Direction = Direction
End Function

;= Essential initialization
Gradient_Create

;****************************************************************************************************
;**
;** Color gradient
;**
;****************************************************************************************************

Const Color_Red = 0
Const Color_Green = 1
Const Color_Blue = 2

Type Gradient_Color
    Field Color[ 2 ]
End Type

Function Gradient_Clear ()
    Delete Each Gradient_Color
    Local Gradient.Gradient = First Gradient
    Gradient\Count = 0
End Function

Function Gradient_Add ( Red , Green , Blue )
    Local Color.Gradient_Color = New Gradient_Color
    Color\Color[ Color_Red ] = Red
    Color\Color[ Color_Green ] = Green
    Color\Color[ Color_Blue ] = Blue
    Local Gradient.Gradient = First Gradient
    Gradient\Count = Gradient\Count + 1
End Function

Function Gradient_Display ()
    ;   Local Red#
    ;   Local Green#
    ;   Local Blue#
    ;Local DirX
    ;Local DirY
    ;   Local Gradient.Gradient
    ;   Local Color.Gradient_Color

    ;DirX = 0
    ;DirY = 0
    ;
    ;Select Gradient_Dir
    ;   Case Gradient_Up
    ;       DirY = -1
    ;   Case Gradient_Down
    ;       DirY = 1
    ;   Case Gradient_Left
    ;       DirX = -1
    ;   Case Gradient_Right
    ;       DirX = 1
    ;End Select

    Local Gradient.Gradient = First Gradient
    Local Gradient_Color_Range# = Gradient\SizeY / ( Gradient\Count - 1 )
    Local PrevColor.Gradient_Color
    Local ThisColor.Gradient_Color = First Gradient_Color
    Local Color_Min[ 2 ]
    Local Color_Max[ 2 ]
    Local Color_Reverse[ 2 ]
    Local Color_Final[ 2 ]
    Local Gradient_Color_Number
    Local Gradient_Color_Offset
    Repeat
        ;= Next color
        PrevColor = ThisColor
        ThisColor = After ThisColor
        Gradient_Color_Number = Gradient_Color_Number + 1
        ;= Convert gradient color number to pixel offset for each color
        Gradient_Color_Offset = Gradient\SizeY * ( Gradient_Color_Number - 1 ) / ( Gradient\Count - 1 )
        ;= Red, green, blue
        For Color = 0 To 2
            If PrevColor\Color[ Color ] > ThisColor\Color[ Color ]
                Color_Min[ Color ] = ThisColor\Color[ Color ]
                Color_Max[ Color ] = PrevColor\Color[ Color ]
                Color_Reverse[ Color ] = True
            Else
                Color_Min[ Color ] = PrevColor\Color[ Color ]
                Color_Max[ Color ] = ThisColor\Color[ Color ]
                Color_Reverse[ Color ] = False
            End If
        Next
        ;= Loop through all pixel lines of this color gradient
        Local Gradient_Line
        Local Color_Range
        Local Gradient_Base_Value
        Local Gradient_Value
        Local Color_Value
        For Gradient_Line = 0 To Gradient_Color_Range
            ;= Loop through individual color components
            For Color = 0 To 2
                ;= Zero-based range
                Color_Range = Color_Max[ Color ] - Color_Min[ Color ]
                ;= Convert pixel range of this gradient section to color range
                Gradient_Base_Value = Gradient_Line * Color_Range / Gradient_Color_Range
                ;= Reverse base value if color value is lower
                If Color_Reverse[ Color ]
                    Gradient_Value = Color_Range - Gradient_Base_Value
                ;= Otherwise keep default base value
                Else
                    Gradient_Value = Gradient_Base_Value
                End If
                ;= Actual gradient color value
                Color_Value = Gradient_Value + Color_Min[ Color ]
                Color_Final[ Color ] = Color_Value
            Next
            ;= Render this line
            Color Color_Final[ Color_Red ] , Color_Final[ Color_Green ] , Color_Final[ Color_Blue ]
            Local X_Left = Gradient\OffsetX
            ;Local X_Right = X_Left + Gradient\SizeX
            Local Y_Top = Gradient\OffsetY + Gradient_Color_Offset + Gradient_Line
            ;Local Y_Bottom = Y_Top
            ;Line X_Left , Y_Top , X_Right , Y_Bottom
            Rect X_Left,Y_Top , Gradient\SizeX,1
        Next
    Until After ThisColor = Null
End Function

;-->
;~IDEal Editor Parameters:
;~C#Blitz3D1105