;-------------------------------------------------------------------------------
; * Interface re-handler (mouse, keyboard, joystick)
; Version 2007 Mar 04 Rev 02
;-------------------------------------------------------------------------------
; Encapsulation enables multi-point input polling


; These can be accessed directly (after using UpdateInput each frame)
Global KeyDown[ 255 ]
Global KeyHit [ 255 ]
Global MouseDown[ 255 ]
Global MouseHit [ 255 ]
Global JoyDown[ 255 ]
Global JoyHit [ 255 ]
Global ShiftDown,ControlDown,AltDown
Global ShiftHit ,ControlHit ,AltHit
Global CtrlDown

; These are not to be accessed directly
Global KeyWasDown  [ 255 ]
Global MouseWasDown[ 255 ]
Global JoyWasDown  [ 255 ]


Function UpdateInput()
    For Index = 0 To 255
        KeyDown[ Index ] = KeyDown( Index )
        KeyHit [ Index ] = KeyHit ( Index )
        MouseDown[ Index ] = MouseDown( Index )
        MouseHit [ Index ] = MouseHit ( Index )
        JoyDown[ Index ] = JoyDown( Index )
        JoyHit [ Index ] = JoyHit ( Index )
    Next
    ControlDown = KeyDown[ Key_LeftControl ] Or KeyDown[ Key_RightControl ]
    ShiftDown   = KeyDown[ Key_LeftShift   ] Or KeyDown[ Key_RightShift   ]
    AltDown     = KeyDown[ Key_LeftAlt     ] Or KeyDown[ Key_RightAlt     ]
    ControlHit = KeyHit[ Key_LeftControl ] Or KeyHit[ Key_RightControl ]
    ShiftHit   = KeyHit[ Key_LeftShift   ] Or KeyHit[ Key_RightShift   ]
    AltHit     = KeyHit[ Key_LeftAlt     ] Or KeyHit[ Key_RightAlt     ]
    CtrlDown = ControlDown
End Function


; Note: Single-point input poll function
Function MouseUp( Button )
    If MouseDown[ Button ]
        MouseWasDown[ Button ] = MouseDown[ Button ]
        Return False 
    Else
        If MouseWasDown[ Button ] <> MouseDown[ Button ]
            MouseWasDown[ Button ] = MouseDown[ Button ]
            Return True 
        Else
            Return False
        EndIf
    EndIf
End Function


; Note: Single-point input poll function
Function JoyUp( Button )
    If JoyDown[ Button ]
        JoyWasDown[ Button ] = JoyDown[ Button ]
        Return False 
    Else
        If JoyWasDown[ Button ] <> JoyDown[ Button ]
            JoyWasDown[ Button ] = JoyDown[ Button ]
            Return True 
        Else
            Return False
        EndIf
    EndIf
End Function


; Note: Single-point input poll function
Function KeyUp( Key )
    If KeyDown[ Key ]
        KeyWasDown[ Key ] = KeyDown[ Key ]
        Return False 
    Else
        If KeyWasDown[ Key ] <> KeyDown[ Key ]
            KeyWasDown[ Key ] = KeyDown[ Key ]
            Return True 
        Else
            Return False
        EndIf
    EndIf
End Function


; Library test function
;Function TestInputs()
;    Local Input 
;
;    Graphics 200,400 , 0,2
;    Repeat 
;        UpdateInput
;        For Input = 0 To 255
;            If MouseHit [ Input ] Then Print "Mouse  HIT"+Input
;            If MouseDown[ Input ] Then Print "Mouse DOWN"+Input
;            If MouseUp  ( Input ) Then Print "Mouse   UP"+Input
;            If KeyHit [ Input ] Then Print "Key  HIT"+Input
;            If KeyDown[ Input ] Then Print "Key DOWN"+Input
;            If KeyUp  ( Input ) Then Print "Key   UP"+Input
;            If JoyHit [ Input ] Then Print "Joy  HIT"+Input
;            If JoyDown[ Input ] Then Print "Joy DOWN"+Input
;            If JoyUp  ( Input ) Then Print "Joy   UP"+Input
;        Next 
;        VWait 
;        Delay 10
;    Until KeyHit[1]
;End Function


;-- Other Functions ------------------------------------------------------------


Function waitkeyordelay( time=0 )
    start=MilliSecs()
    Repeat
        For key=0 To 255
            If KeyHit( key ) Then esc=True:Exit
        Next
        For button=0 To 3
            If MouseHit( button ) Then esc=True:Exit
        Next
        For joy=0 To 255
            If JoyHit( joy ) Then esc=True:Exit
        Next 
        If time>0
            If MilliSecs()-start>=time
                esc=True
            EndIf
        EndIf
    Until esc
    FlushKeys 
    FlushMouse 
    FlushJoy 
End Function


Function AnyKeyDown% ()
    For Counter = 1 To 255
      If KeyDown ( Counter ) > 0
        AnyKey = Counter
        Exit
      EndIf
    Next
    FlushKeys ()
    Return AnyKey
End Function


Function AnyKeyHit% ()
    For Counter = 1 To 255
      If KeyHit ( Counter ) > 0
        AnyKey = Counter
        Exit
      EndIf
    Next
    FlushKeys ()
    Return AnyKey
End Function

; reset all input device poll values (keyboard, mouse, joystick)
; both auto and manual by default
Function FlushInput( AutoOnly = False )
    Local Input

    If Not AutoOnly
        For Input = 0 To 255
            KeyHit Input
            ;KeyDown Input
            MouseHit Input
            ;MouseDown Input
            JoyHit Input
            ;JoyDown Input
        Next
    EndIf 
    FlushKeys 
    FlushMouse 
    FlushJoy 
End Function
